include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
	[repeat id_or_id_dot]																			[NL]
end define 

define id_or_id_dot
		[SPOFF] [id] '. [id] '. [id] [SPON]	[SP]
	|	[SPOFF] [id] '. [id] [SPON]	[SP]
	|	[id] [SP]
end define

function main
	replace [program]
		P [program]
	
	construct Service [repeat service]
		_ [^ P] 
	deconstruct Service
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceNameID [id] 
		_ [unquote ServiceNameNoPrefix]
	export ServiceName [id]
		ServiceNameID
	
	construct Types [repeat types]
		_ [^ P] 
	construct Elements [repeat schema_element]
		_ [^ Types]
	construct ComplexTypes [repeat complex_type]
		_ [^ Types]
		
	construct Messages [repeat message]
		_ [^ P]
	
	construct SchemaElementFacts [repeat fact]
		_ [getElements each Elements]
	construct PartFacts [repeat fact]
		_ [getMessages each Messages]
	construct TypeFacts [repeat fact]
		_ [getElementsInTypes each ComplexTypes]
	
	construct Facts [repeat fact]
		SchemaElementFacts [. PartFacts] [. TypeFacts]
		
	by 
		Facts
end function 

function getElements Element [schema_element]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Element
		'< _ [opt prefix] 'element AttrList [opt attribute_list] '>
			Contents [repeat schema_scope]			
		'</ _ [opt prefix] 'element>
	construct ElementNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ElementNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct ElementNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct ElementName [id]
		_ [unquote ElementNameNoPrefix]
		
	construct SingletonElements [repeat schema_element]
		_ [^ Contents]
	
	construct NewFacts [repeat fact]
		_ [getSingletonElements ElementName each SingletonElements]
		
	by 
		PreviousFacts [. NewFacts]
end function

function getSingletonElements ParentElementName [id] Element [schema_element]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Element
		'< _ [opt prefix] 'element AttrList [opt attribute_list] '/>
	construct ElementNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ElementNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct ElementNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct ElementName [id]
		_ [unquote ElementNameNoPrefix]
		
	construct ElementTypeAttr [repeat type_attr]	
		_ [^ AttrList]
	deconstruct ElementTypeAttr
		_ [opt prefix] 'type = Type [stringlit] 
		_ [repeat type_attr]	
	construct ElementTypeNoPrefix [stringlit]
		Type [deletePrefix]
	construct ElementType [id]
		_ [unquote ElementTypeNoPrefix]	
		
	import ServiceName [id]
		
	construct NewFact [fact]
		'hasA ServiceName '. ParentElementName '. ElementName ServiceName '. ElementType
	by 
		PreviousFacts [. NewFact]
end function

function getMessages Msg [message]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Msg
		'< _ [opt prefix] 'message AttrList [opt attribute_list] '>
			MsgContents [repeat message_scope] 
		'</ _ [opt prefix] 'message> 
	construct MsgNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct MsgNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct MsgNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct MsgName [id]
		_ [unquote MsgNameNoPrefix]
		
	construct Parts [repeat part]
		_ [^ MsgContents]
		
	construct NewFacts [repeat fact]
		_ [getParts MsgName each Parts]
	by 
		PreviousFacts [. NewFacts]
end function

function getParts MsgName [id] Part [part]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Part
		'< _ [opt prefix] 'part AttrList [opt attribute_list] '/> 
	construct PartTypeAttr [repeat type_attr]
		_ [^ AttrList]
	deconstruct PartTypeAttr
		_ [opt prefix] 'type = TypeWithPrefix [stringlit] 
		_ [repeat type_attr]	
	construct PartTypeNoPrefix [stringlit]
		TypeWithPrefix [deletePrefix]
	construct PartType [id]
		_ [unquote PartTypeNoPrefix]	
		
	construct PartNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct PartNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct PartNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct PartName [id]
		_ [unquote PartNameNoPrefix]
	
	import ServiceName [id]	
		
	construct NewFact [fact]
		'hasA ServiceName '. MsgName '. PartName ServiceName '. PartType	
	by 
		PreviousFacts [. NewFact]
end function

function getElementsInTypes ComplexType [complex_type]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct ComplexType
		'< _ [opt prefix] 'complexType AttrList [opt attribute_list] '>
			Contents [repeat complexType_scope]			
		'</ _ [opt prefix] 'complexType>
	construct TypeNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct TypeNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct TypeNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct TypeName [id]
		_ [unquote TypeNameNoPrefix]
		
	construct SingletonElements [repeat schema_element]
		_ [^ Contents]
	
	construct NewFacts [repeat fact]
		_ [getTypeElements TypeName  each SingletonElements]
		
	by 
		PreviousFacts [. NewFacts]
end function

function getTypeElements ParentElmtName [id] Element [schema_element]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Element
		'< _ [opt prefix] 'element AttrList [opt attribute_list] '/>
	construct ElementNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ElementNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct ElementNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct ElementName [id]
		_ [unquote ElementNameNoPrefix]
	
	construct ElementTypeAttr [repeat type_attr]	
		_ [^ AttrList]
	deconstruct ElementTypeAttr
		_ [opt prefix] 'type = Type [stringlit] 
		_ [repeat type_attr]	
	construct ElementTypeNoPrefix [stringlit]
		Type [deletePrefix]
	construct ElementType [id]
		_ [unquote ElementTypeNoPrefix]		
		
	import ServiceName [id]	
	construct NewFact [fact]
		'hasA ServiceName '. ParentElmtName '. ElementName ServiceName '. ElementType
	by 
		PreviousFacts [. NewFact]
end function

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
